Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs	(revision 4423)
@@ -36,4 +36,5 @@
 using HeuristicLab.Hive.Slave.ExecutionEngine;
 using HeuristicLab.Tracing;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Hive.Slave.Core {
@@ -44,4 +45,11 @@
     public static bool abortRequested { get; set; }
 
+    private Dictionary<Guid, Executor> engines = new Dictionary<Guid, Executor>();
+    private Dictionary<Guid, AppDomain> appDomains = new Dictionary<Guid, AppDomain>();
+    private Dictionary<Guid, JobDto> jobs = new Dictionary<Guid, JobDto>();
+
+    private WcfService wcfService;
+    private HeartbeatManager heartbeatManager;
+
     private bool currentlyFetching;
     private bool CurrentlyFetching {
@@ -55,10 +63,11 @@
     }
 
-    private Dictionary<Guid, Executor> engines = new Dictionary<Guid, Executor>();
-    private Dictionary<Guid, AppDomain> appDomains = new Dictionary<Guid, AppDomain>();
-    private Dictionary<Guid, JobDto> jobs = new Dictionary<Guid, JobDto>();
-
-    private WcfService wcfService;
-    private HeartbeatManager beat;
+    public Dictionary<Guid, Executor> ExecutionEngines {
+      get { return engines; }
+    }
+
+    internal Dictionary<Guid, JobDto> Jobs {
+      get { return jobs; }
+    }
 
     /// <summary>
@@ -70,5 +79,5 @@
       SlaveConsoleServer server = new SlaveConsoleServer();
       server.Start();
-      
+
       ConfigManager manager = ConfigManager.Instance;
       manager.Core = this;
@@ -95,6 +104,6 @@
     private void StartHeartbeats() {
       //Initialize the heartbeat
-      beat = new HeartbeatManager { Interval = new TimeSpan(0, 0, 10) };
-      beat.StartHeartbeat();
+      heartbeatManager = new HeartbeatManager { Interval = new TimeSpan(0, 0, 10) };
+      heartbeatManager.StartHeartbeat();
     }
 
@@ -111,6 +120,4 @@
       wcfService.GetFinishedJobResultCompleted += new EventHandler<StoreFinishedJobResultCompletedEventArgs>(wcfService_StoreFinishedJobResultCompleted);
       wcfService.ProcessSnapshotCompleted += new EventHandler<ProcessSnapshotCompletedEventArgs>(wcfService_ProcessSnapshotCompleted);
-      wcfService.ConnectionRestored += new EventHandler(wcfService_ConnectionRestored);
-      //wcfService.ServerChanged += new EventHandler(wcfService_ServerChanged);
       wcfService.Connected += new EventHandler(wcfService_Connected);
     }
@@ -120,6 +127,4 @@
       wcfService.GetFinishedJobResultCompleted -= new EventHandler<StoreFinishedJobResultCompletedEventArgs>(wcfService_StoreFinishedJobResultCompleted);
       wcfService.ProcessSnapshotCompleted -= new EventHandler<ProcessSnapshotCompletedEventArgs>(wcfService_ProcessSnapshotCompleted);
-      wcfService.ConnectionRestored -= new EventHandler(wcfService_ConnectionRestored);
-      //wcfService.ServerChanged -= new EventHandler(wcfService_ServerChanged);
       wcfService.Connected -= new EventHandler(wcfService_Connected);
     }
@@ -135,5 +140,10 @@
         case MessageContainer.MessageType.AbortJob:
           if (engines.ContainsKey(container.JobId))
-            engines[container.JobId].Abort();
+            try {
+              engines[container.JobId].Abort();
+            }
+            catch (AppDomainUnloadedException) {
+              // appdomain already unloaded. Finishing job probably ongoing
+            }
           else
             Logger.Error("AbortJob: Engine doesn't exist");
@@ -156,5 +166,5 @@
         //Snapshot is ready and can be sent back to the Server
         case MessageContainer.MessageType.SnapshotReady:
-          ThreadPool.QueueUserWorkItem(new WaitCallback(GetSnapshot), container.JobId);
+          GetSnapshot(container.JobId);
           break;
 
@@ -168,15 +178,12 @@
           break;
 
-
         //A Job has finished and can be sent back to the server
         case MessageContainer.MessageType.FinishedJob:
-          ThreadPool.QueueUserWorkItem(new WaitCallback(GetFinishedJob), container.JobId);
-          break;
-
+          SendFinishedJob(container.JobId);
+          break;
 
         //When the timeslice is up
         case MessageContainer.MessageType.UptimeLimitDisconnect:
           Logger.Info("Uptime Limit reached, storing jobs and sending them back");
-
           ShutdownRunningJobsAndSubmitSnapshots();
           break;
@@ -201,5 +208,5 @@
           Logger.Debug("Stopping heartbeat");
           abortRequested = true;
-          beat.StopHeartBeat();
+          heartbeatManager.StopHeartBeat();
           Logger.Debug("Logging out");
           WcfService.Instance.Logout(ConfigManager.Instance.GetClientInfo().Id);
@@ -216,6 +223,9 @@
 
         case MessageContainer.MessageType.GetChildJobs:
-          // send the job back to hive
           GetChildJobs((MessageContainerWithCallback<SerializedJobList>)container);
+          break;
+
+        case MessageContainer.MessageType.DeleteChildJobs:
+          wcfService.DeleteChildJobs(container.JobId);
           break;
       }
@@ -224,8 +234,12 @@
     private void GetChildJobs(MessageContainerWithCallback<SerializedJobList> mc) {
       ResponseObject<SerializedJobList> response = wcfService.GetChildJobs(mc.JobId);
-      if (response.StatusMessage != ResponseStatus.Ok) {
-        Logger.Error("GetChildJobs failed: " + response.StatusMessage);
+      if (response != null && response.StatusMessage == ResponseStatus.Ok) {
+        mc.Callback(response.Obj);
       } else {
-        mc.Callback(response.Obj);
+        if (response != null) {
+          Logger.Error(string.Format("GetChildJobs failed: {0}", response.StatusMessage));
+        } else {
+          Logger.Error("GetChildJobs failed.");
+        }
       }
     }
@@ -234,5 +248,5 @@
       ResponseObject<JobDto> response = wcfService.PauseJob(mc.SerializedJob);
       KillAppDomain(mc.JobId);
-      if (response.StatusMessage != ResponseStatus.Ok) {
+      if (response == null || response.StatusMessage != ResponseStatus.Ok) {
         Logger.Error("PauseJob failed: " + response.StatusMessage);
       }
@@ -241,5 +255,5 @@
     private ResponseObject<JobDto> AddChildJob(MessageContainerWithJob mc) {
       ResponseObject<JobDto> response = wcfService.AddChildJob(mc.JobId, mc.SerializedJob);
-      if (response.StatusMessage != ResponseStatus.Ok) {
+      if (response == null || response.StatusMessage != ResponseStatus.Ok) {
         Logger.Error("AddChildJob failed: " + response.StatusMessage);
       }
@@ -267,8 +281,8 @@
     /// </summary>
     /// <param name="jobId"></param>
-    private void GetFinishedJob(object jobId) {
-      Guid jId = (Guid)jobId;
-      Logger.Info("Getting the finished job with id: " + jId);
+    private void SendFinishedJob(object jobId) {
       try {
+        Guid jId = (Guid)jobId;
+        Logger.Info("Getting the finished job with id: " + jId);
         if (!engines.ContainsKey(jId)) {
           Logger.Info("Engine doesn't exist");
@@ -278,47 +292,49 @@
         byte[] sJob = engines[jId].GetFinishedJob();
 
-        if (WcfService.Instance.LoggedIn) {
+        try {
           Logger.Info("Sending the finished job with id: " + jId);
-          wcfService.GetFinishedJobResultAsync(ConfigManager.Instance.GetClientInfo().Id, jId, sJob, 1.0, engines[jId].CurrentException, true);
+          wcfService.GetFinishedJobResultAsync(ConfigManager.Instance.GetClientInfo().Id, jId, sJob, engines[jId].ExecutionTime, engines[jId].CurrentException, true);
+        }
+        catch (Exception e) {
+          Logger.Info("Transmitting to server failed. Storing the finished job with id: " + jId + " to hdd (" + e.ToString() + ")");
+          JobStorageManager.PersistObjectToDisc(wcfService.ServerIp, 0, jId, sJob); // [chn] Port is not unique anymore (since we need two ports for http and net.tcp-streaming). also the port is now specified only in app.config. use port 0 for the moment
+        }
+        finally {
+          KillAppDomain(jId); // kill app-domain in every case
+        }
+      }
+      catch (Exception e) {
+        OnExceptionOccured(e);
+      }
+    }
+
+    private void GetSnapshot(object jobId) {
+      try {
+        Logger.Info("Fetching a snapshot for job " + jobId);
+        Guid jId = (Guid)jobId;
+        byte[] obj = engines[jId].GetSnapshot();
+        wcfService.ProcessSnapshotSync(ConfigManager.Instance.GetClientInfo().Id, jId, obj, engines[jId].ExecutionTime, null);
+
+        //Uptime Limit reached, now is a good time to destroy this jobs.
+        Logger.Debug("Checking if uptime limit is reached");
+        if (!UptimeManager.Instance.IsAllowedToCalculate()) {
+          Logger.Debug("Uptime limit reached");
+          Logger.Debug("Killing Appdomain");
+          KillAppDomain(jId);
+          //Still anything running?  
+          if (engines.Count == 0) {
+            Logger.Info("All jobs snapshotted and sent back, disconnecting");
+            WcfService.Instance.Disconnect();
+          } else {
+            Logger.Debug("There are still active Jobs in the Field, not disconnecting");
+          }
         } else {
-          Logger.Info("Storing the finished job with id: " + jId + " to hdd");
-          JobStorageManager.PersistObjectToDisc(wcfService.ServerIp, 0, jId, sJob); // [chn] Port is not unique anymore (since we need two ports for http and net.tcp-streaming). also the port is now specified only in app.config. use port 0 for the moment
-          KillAppDomain(jId);
-        }
-      }
-      catch (InvalidStateException ise) {
-        Logger.Error("Invalid State while Snapshoting:", ise);
-      }
-    }
-
-    private void GetSnapshot(object jobId) {
-      Logger.Info("Fetching a snapshot for job " + jobId);
-      Guid jId = (Guid)jobId;
-      byte[] obj = engines[jId].GetSnapshot();
-      Logger.Debug("BEGIN: Sending snapshot sync");
-      wcfService.ProcessSnapshotSync(ConfigManager.Instance.GetClientInfo().Id,
-        jId,
-        obj,
-        engines[jId].Progress,
-        null);
-      Logger.Debug("END: Sended snapshot sync");
-      //Uptime Limit reached, now is a good time to destroy this jobs.
-      Logger.Debug("Checking if uptime limit is reached");
-      if (!UptimeManager.Instance.IsAllowedToCalculate()) {
-        Logger.Debug("Uptime limit reached");
-        Logger.Debug("Killing Appdomain");
-        KillAppDomain(jId);
-        //Still anything running?  
-        if (engines.Count == 0) {
-          Logger.Info("All jobs snapshotted and sent back, disconnecting");
-          WcfService.Instance.Disconnect();
-        } else {
-          Logger.Debug("There are still active Jobs in the Field, not disconnecting");
-        }
-
-      } else {
-        Logger.Debug("Restarting the job" + jobId);
-        engines[jId].StartOnlyJob();
-        Logger.Info("Restarted the job" + jobId);
+          Logger.Debug("Restarting the job" + jobId);
+          engines[jId].StartOnlyJob();
+          Logger.Info("Restarted the job" + jobId);
+        }
+      }
+      catch (Exception e) {
+        OnExceptionOccured(e);
       }
     }
@@ -349,13 +365,9 @@
       if (e.Result.StatusMessage != ResponseStatus.GetJob_NoJobsAvailable) {
         Logger.Info("Received new job with id " + e.Result.Obj.Id);
-        bool sandboxed = false;
         Logger.Debug("Fetching plugins for job " + e.Result.Obj.Id);
         try {
-
           PluginCache.Instance.PreparePlugins(e.Result.Obj.PluginsNeeded);
           PluginCache.Instance.CopyPluginsForJob(e.Result.Obj.PluginsNeeded, e.Result.Obj.Id);
 
-          //        foreach (CachedHivePluginInfoDto plugininfo in PluginCache.Instance.GetPlugins(e.Result.Job.PluginsNeeded))
-          //        files.AddRange(plugininfo.PluginFiles);
           Logger.Debug("Plugins fetched for job " + e.Result.Obj.Id);
           String pluginDir = Path.Combine(PluginCache.Instance.PluginRepositoryDir, e.Result.Obj.Id.ToString());
@@ -375,10 +387,9 @@
               engine.Start(e.Data);
               engines.Add(e.Result.Obj.Id, engine);
-
               SlaveStatusInfo.JobsFetched++;
               Logger.Info("Increment FetchedJobs to:" + SlaveStatusInfo.JobsFetched);
             }
           }
-          beat.InterruptHeartBeatThread();
+          heartbeatManager.AwakeHeartBeatThread();
         }
         catch (Exception exception) {
@@ -387,5 +398,5 @@
           CurrentlyFetching = false;
           KillAppDomain(e.Result.Obj.Id);
-          wcfService.StoreFinishedJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, e.Result.Obj.Id, new byte[] { }, 1, exception, true);
+          wcfService.StoreFinishedJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, e.Result.Obj.Id, new byte[] { }, e.Result.Obj.ExecutionTime, exception.ToString(), true);
         }
       } else {
@@ -406,5 +417,5 @@
         SlaveStatusInfo.JobsProcessed++;
         Logger.Info("Increased ProcessedJobs to:" + SlaveStatusInfo.JobsProcessed);
-        beat.InterruptHeartBeatThread();
+        heartbeatManager.AwakeHeartBeatThread();
       } else {
         Logger.Error("Sending of job " + e.Result.JobId + " failed, job has been wasted. Message: " + e.Result.StatusMessage);
@@ -433,12 +444,8 @@
         FetchCalendarFromServer();
       }
-      //if the fetching from the server failed - still set the client online... maybe we get 
-      //a result within the next few heartbeats      
-      //if (!UptimeManager.Instance.CalendarAvailable || UptimeManager.Instance.IsOnline()) {
       Logger.Info("CalendarAvailable is " + UptimeManager.Instance.CalendarAvailable + " and IsOnline is: " + UptimeManager.Instance.IsAllowedToCalculate());
-      Logger.Info("Setting client online");
-      wcfService.Login(ConfigManager.Instance.GetClientInfo());
+      CurrentlyFetching = false;
+      CheckRunningAppDomains();
       JobStorageManager.CheckAndSubmitJobsFromDisc();
-      CurrentlyFetching = false;
     }
 
@@ -459,12 +466,9 @@
     }
 
-    //this is a little bit tricky - 
-    void wcfService_ConnectionRestored(object sender, EventArgs e) {
-      Logger.Info("Reconnected to old server - checking currently running appdomains");
-
+    private void CheckRunningAppDomains() {
       foreach (KeyValuePair<Guid, Executor> execKVP in engines) {
         if (execKVP.Value.ExecutionState != ExecutionState.Started && execKVP.Value.CurrentMessage == MessageContainer.MessageType.NoMessage) {
           Logger.Info("Checking for JobId: " + execKVP.Value.JobId);
-          Thread finThread = new Thread(new ParameterizedThreadStart(GetFinishedJob));
+          Thread finThread = new Thread(new ParameterizedThreadStart(SendFinishedJob));
           finThread.Start(execKVP.Value.JobId);
         }
@@ -474,10 +478,9 @@
     #endregion
 
-    public Dictionary<Guid, Executor> ExecutionEngines {
-      get { return engines; }
-    }
-
-    internal Dictionary<Guid, JobDto> Jobs {
-      get { return jobs; }
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception e) {
+      Logger.Error("Error: " + e.ToString());
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Exception>(e));
     }
 
@@ -498,5 +501,20 @@
           if (appDomains.ContainsKey(id)) {
             appDomains[id].UnhandledException -= new UnhandledExceptionEventHandler(appDomain_UnhandledException);
-            AppDomain.Unload(appDomains[id]);
+
+            int repeat = 5;
+            while (repeat > 0) {
+              try {
+                AppDomain.Unload(appDomains[id]);
+                repeat = 0;
+              }
+              catch (CannotUnloadAppDomainException) {
+                Logger.Error("Could not unload AppDomain, will try again in 1 sec.");
+                Thread.Sleep(1000);
+                repeat--;
+                if (repeat == 0) {
+                  throw; // rethrow and let app crash
+                }
+              }
+            }
             appDomains.Remove(id);
           }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeartbeatManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeartbeatManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeartbeatManager.cs	(revision 4423)
@@ -34,4 +34,5 @@
 using System.Threading;
 using HeuristicLab.Hive.Slave.Communication.SlaveFacade;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Hive.Slave.Core {
@@ -40,15 +41,11 @@
   /// </summary>
   public class HeartbeatManager {
-
-    private bool offline;
-
+    private static object locker = new object();
     public TimeSpan Interval { get; set; }
-
     private Thread heartBeatThread;
-
-    private static object locker = new object();
+    private AutoResetEvent waitHandle;
 
     public HeartbeatManager() {
-      Interval = new TimeSpan(0,0,10);
+      Interval = new TimeSpan(0, 0, 10);
     }
 
@@ -68,73 +65,65 @@
     /// </summary>
     public void StartHeartbeat() {
+      this.waitHandle = new AutoResetEvent(true);
       wcfService = WcfService.Instance;
       wcfService.ProcessHeartBeatCompleted += new EventHandler<ProcessHeartBeatCompletedEventArgs>(wcfService_ProcessHeartBeatCompleted);
       abortThreadPending = false;
-      heartBeatThread = GetHeartBeatThread();
+      heartBeatThread = new Thread(RunHeartBeatThread);
       heartBeatThread.Start();
     }
 
-    private Thread GetHeartBeatThread() {
-      return new Thread(() => {
-        while (!abortThreadPending) {
-          try {
-            lock (locker) {
-              if (wcfService.ConnState != NetworkEnum.WcfConnState.Connected) {
-                wcfService.Connect(); // Login happens automatically upon successufl connection
-              }
-              if (!wcfService.LoggedIn) {
-                wcfService.Login(ConfigManager.Instance.GetClientInfo()); // if login faild previously try again
+    /// <summary>
+    /// Stop the heartbeat
+    /// </summary>
+    public void StopHeartBeat() {
+      abortThreadPending = true;
+      waitHandle.Set();
+      heartBeatThread.Join();
+    }
+    
+    /// <summary>
+    /// use this method to singalize there is work to do (to avoid the waiting period if its clear that actions are required)
+    /// </summary>
+    public void AwakeHeartBeatThread() {
+      waitHandle.Set();
+    }
+
+    private void RunHeartBeatThread() {
+      while (!abortThreadPending) {
+        try {
+          lock (locker) {
+            if (wcfService.ConnState != NetworkEnum.WcfConnState.Connected) {
+              wcfService.Connect(ConfigManager.Instance.GetClientInfo()); // Login happens automatically upon successufl connection
+            }
+            if(wcfService.ConnState == NetworkEnum.WcfConnState.Connected) {
+              SlaveDto info = ConfigManager.Instance.GetClientInfo();
+
+              HeartBeatData heartBeatData = new HeartBeatData {
+                SlaveId = info.Id,
+                FreeCores = info.NrOfCores.HasValue ? info.NrOfCores.Value - ConfigManager.Instance.GetUsedCores() : 0,
+                FreeMemory = GetFreeMemory(),
+                JobProgress = ConfigManager.Instance.GetExecutionTimeOfAllJobs(),
+                IsAllowedToCalculate = UptimeManager.Instance.IsAllowedToCalculate() && UptimeManager.Instance.CalendarAvailable
+              };
+
+              if (!heartBeatData.IsAllowedToCalculate) {
+                // stop all running jobs and send snapshots to server
+                MessageQueue.GetInstance().AddMessage(MessageContainer.MessageType.UptimeLimitDisconnect);
               }
 
-              if (wcfService.LoggedIn) {
-                SlaveDto info = ConfigManager.Instance.GetClientInfo();
-
-                HeartBeatData heartBeatData = new HeartBeatData {
-                  SlaveId = info.Id,
-                  FreeCores = info.NrOfCores - ConfigManager.Instance.GetUsedCores(),
-                  FreeMemory = GetFreeMemory(),
-                  JobProgress = ConfigManager.Instance.GetProgressOfAllJobs(),
-                  IsAllowedToCalculate = UptimeManager.Instance.IsAllowedToCalculate() && UptimeManager.Instance.CalendarAvailable
-                };
-
-                if (!heartBeatData.IsAllowedToCalculate) {
-                  // stop all running jobs and send snapshots to server
-                  MessageQueue.GetInstance().AddMessage(MessageContainer.MessageType.UptimeLimitDisconnect);
-                }
-
-                Logger.Debug("Sending Heartbeat: " + heartBeatData);
-                wcfService.ProcessHeartBeatSync(heartBeatData);                
-              }
-
-            } // lock
-          }
-          catch (Exception e) {
-            Logger.Error("Heartbeat Thread failed badly: " + e.Message);
-          }
-
-          try {
-            heartBeatThreadIsSleepingLock.EnterWriteLock();
-            heartBeatThreadIsSleeping = true;
-            heartBeatThreadIsSleepingLock.ExitWriteLock();
-
-            Thread.Sleep(Interval);
-
-            heartBeatThreadIsSleepingLock.EnterWriteLock();
-            heartBeatThreadIsSleeping = false;
-            heartBeatThreadIsSleepingLock.ExitWriteLock();
-          }
-          catch (ThreadInterruptedException e) {
-            Logger.Debug("Heartbeat sleep interrupted");
-          }
-        } // while
-        abortThreadPending = false;
-        Logger.Debug("Heartbeat thread stopped");
-      });
-    }
-
-    private int GetFreeMemory() {
-      PerformanceCounter counter = new PerformanceCounter("Memory", "Available Bytes", true);
-      int mb = (int)(counter.NextValue() / 1024 / 1024);
-      return mb;
+              Logger.Debug("Sending Heartbeat: " + heartBeatData);
+              wcfService.ProcessHeartBeatSync(heartBeatData);
+            }
+          } // lock
+        }
+        catch (Exception e) {
+          Logger.Error("Heartbeat Thread failed badly: " + e.Message);
+          OnExceptionOccured(e);
+        }
+        waitHandle.WaitOne(this.Interval);
+      } // while
+      waitHandle.Close();
+      abortThreadPending = false;
+      Logger.Debug("Heartbeat thread stopped");
     }
 
@@ -144,25 +133,19 @@
     }
 
-    public void StopHeartBeat() {
-      abortThreadPending = true;
-      heartBeatThread.Interrupt();
-      heartBeatThread.Join();
+    #region Eventhandler
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception e) {
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Exception>(e));
     }
+    #endregion
 
-    /// <summary>
-    /// use this method to singalize there is work to do (to avoid the waiting period if its clear that actions are required)
-    /// </summary>
-    public void InterruptHeartBeatThread() {
-      // deal with ReadWriteLock to avoid interrupting the thread while it is in SleepOrWait due to another reason (like waiting for a resource in a lock-statement)
-      heartBeatThreadIsSleepingLock.EnterReadLock();
-      Debug.WriteLine("InterruptHeartBeatThread");
-      if (heartBeatThreadIsSleeping) {
-        Debug.WriteLine("will interrupt heartbeatthread");
-        heartBeatThread.Interrupt();
-      } else {
-        Debug.WriteLine("will not interrupt heartbeatthread");
-      }
-      heartBeatThreadIsSleepingLock.ExitReadLock();
+    #region Helpers
+    private int GetFreeMemory() {
+      PerformanceCounter counter = new PerformanceCounter("Memory", "Available Bytes", true);
+      int mb = (int)(counter.NextValue() / 1024 / 1024);
+      return mb;
     }
+    #endregion
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/JobStorage/JobStorageManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/JobStorage/JobStorageManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/JobStorage/JobStorageManager.cs	(revision 4423)
@@ -45,5 +45,5 @@
     public static void CheckAndSubmitJobsFromDisc() {
       for (int index = storedJobsList.Count; index > 0; index--) {
-        if (WcfService.Instance.LoggedIn && (storedJobsList[index - 1].ServerIP == WcfService.Instance.ServerIp)) {
+        if (storedJobsList[index - 1].ServerIP == WcfService.Instance.ServerIp) {
           String filename = storedJobsList[index - 1].ServerIP + "." + storedJobsList[index - 1].ServerPort + "." + storedJobsList[index - 1].JobID.ToString();
           Logger.Info("Sending stored job " + storedJobsList[index - 1].JobID + " to the server");
@@ -51,5 +51,5 @@
             byte[] job = File.ReadAllBytes(path + filename + ".dat");
             if (WcfService.Instance.IsJobStillNeeded(storedJobsList[index - 1].JobID).StatusMessage == ResponseStatus.Ok) {
-              ResponseResultReceived res = WcfService.Instance.StoreFinishedJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, storedJobsList[index - 1].JobID, job, 1.00, null, true);
+              ResponseResultReceived res = WcfService.Instance.StoreFinishedJobResultsSync(ConfigManager.Instance.GetClientInfo().Id, storedJobsList[index - 1].JobID, job, TimeSpan.Zero, null, true); // unfortunately we do not have the correct ExecutionTime since we would need to unzip the job for that
               Logger.Info("Sending of job " + storedJobsList[index - 1].JobID + " done");
             }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/SlaveConsoleCommunicator.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/SlaveConsoleCommunicator.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/SlaveConsoleCommunicator.cs	(revision 4423)
@@ -20,11 +20,6 @@
     public void SetConnection(ConnectionContainer container) {
       ConfigManager.Instance.SetServerIP(container);
-      //WcfService.Instance.Connect(container.IPAdress);
       WcfService.Instance.ServerIp = container.IPAdress;
     }
-
-    //public void Disconnect() {
-    //  WcfService.Instance.Disconnect();
-    //}   
 
     public ConnectionContainer GetCurrentConnection() {
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/TransferObjects/JobStatus.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/TransferObjects/JobStatus.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/SlaveConsoleService/TransferObjects/JobStatus.cs	(revision 4423)
@@ -43,5 +43,5 @@
     /// </summary>
     [DataMember]
-    public double Progress { get; set; }
+    public TimeSpan ExecutionTime { get; set; }
   }
 }
